<?php
	 
	require_once('SSI.php');
	require_once('Sources/Subs-Seo4SMF.php');


	global $smcFunc, $scripturl, $boardurl, $modSettings, $context, $txt;

	if (isset($modSettings['seo4smf_split_char']))
	    $split_char = $modSettings['seo4smf_split_char'];
	else
	    $split_char = "_";
	 
	 
	header('Content-Type: application/xml');
	 
	$request = $smcFunc['db_query']('', '
	    SELECT poster_time
	    FROM {db_prefix}messages
	    WHERE id_msg >= {int:maxmsgid}
	    ORDER BY id_msg DESC
	    LIMIT 10',
			array(
				'maxmsgid' => $modSettings['max_msg_id'] - 30,
			)
	    );
	$latest_post_times = array(time());
	while ($row = $smcFunc['db_fetch_assoc']($request))
	$latest_post_times[] = $row['poster_time'];
	$smcFunc['db_free_result']($request);
	 
	 
	echo '<?xml version="1.0" encoding="'.$context['character_set'].'"?' . '>
<?xml-stylesheet type="text/xsl" href="'.$boardurl.'/sitemap.xsl"?>
<urlset xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd" xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">';

	echo '
	    <url>
	    <loc>', $scripturl, '</loc>
	    <lastmod>', posts_max_time($latest_post_times), '</lastmod>
	    <changefreq>', posts_to_freq($latest_post_times), '</changefreq>
	    <priority>1.0</priority>
	    </url>';
	 
	$request = $smcFunc['db_query']('', '
	    SELECT poster_time
	    FROM {db_prefix}messages
	    WHERE id_msg >= {int:maxmsgid}
	    ORDER BY id_msg DESC
	    LIMIT 10',
			array(
				'maxmsgid' => $modSettings['max_msg_id'] - 30,
			)
	    );
	$latest_post_times = array(time());
	while ($row = $smcFunc['db_fetch_assoc']($request))
	$latest_post_times[] = $row['poster_time'];
	$smcFunc['db_free_result']($request);
	 
	 
	$request = $smcFunc['db_query']('', '
	    SELECT id_board,name
	    FROM {db_prefix}boards where member_groups LIKE "%-1%"',
			array(
			)
	    );
	$boards = array();
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
	    $request2 = $smcFunc['db_query']('', '
	        SELECT poster_time
	        FROM {db_prefix}messages
	        WHERE id_board = {int:id_board}' . ($modSettings['totalMessages'] > 100000 ? '
	        AND id_msg >= {int:maxmsgidd} ' : '') . '
	        ORDER BY id_msg DESC
	        LIMIT 10',
			array(
				'id_board' => $row[id_board],
				'maxmsgidd' => $modSettings['max_msg_id'] * 0.5,
			)
	    );
	    $board_post_times = array(time());
	    while ($row2 = $smcFunc['db_fetch_assoc']($request2))
	    $board_post_times[] = $row2['poster_time'];
	    $smcFunc['db_free_result']($request2);
	     
	    $boards[] = array(
	    'id' => $row['id_board'],
	        'times' => $board_post_times,
	        'name' => $row['name'],
	        );
	}
	$smcFunc['db_free_result']($request);
	 
	// Now the boards! We must see if the forum's has nice short URLs or not.
	    foreach ($boards as $board)
	    {
	        $board_name = remove_signs($board['name']);
	        $board_name = strtolower(str_replace(" ", $split_char, $board_name));
	        $scripturl1 = str_replace("/index.php", "", $scripturl);
	        echo '
	            <url>
	            <loc>', $scripturl1, '/', $board_name, '-b', $board['id'], '.0/</loc>
	            <lastmod>', posts_max_time($board['times']), '</lastmod>
	            <changefreq>', posts_to_freq($board['times']), '</changefreq>
	            <priority>', posts_to_priority(0.8, $board['times']), '</priority>
	            </url>';
	    }
	 
	 
	 
	$request = $smcFunc['db_query']('', '
	    SELECT id_topic
	    FROM {db_prefix}topics
	    ORDER BY num_views + num_replies DESC
	    LIMIT 20000',
			array(
			)
	    );
	$topics = array();
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
	    $request2 = $smcFunc['db_query']('', '
	        SELECT poster_time,subject,id_board
	        FROM {db_prefix}messages
	        WHERE id_topic = {int:id_topic}
	        ORDER BY id_msg DESC
	        LIMIT 10',
			array(
				'id_topic' => $row[id_topic],
			)
	    );
	    //$topic_post_times = array(time());
	    $topic_post_times = array();
	    //$subject = array();
	    $subject="";
	    while ($row2 = $smcFunc['db_fetch_assoc']($request2))
	    {
	        $topic_post_times[] = $row2['poster_time'];
	        if (empty($subject))$subject = $row2['subject'];
	        $board = $row2['id_board'];
	    }
	     
	    $topics[] = array(
	    'id' => $row['id_topic'],
	        'times' => $topic_post_times,
	        'subject' => $subject,
	        'board' => $board,
	        );
	    $smcFunc['db_free_result']($request2);
	}
	$smcFunc['db_free_result']($request);
	 
	// Popular topics too...
	 
	    foreach ($topics as $topic)
	    {
	        $board_exist = 0;
	        foreach ($boards as $board)
	        {
	            if ($board['id'] == $topic['board'])
	            {
	                $board_name = remove_signs($board['name']);
	                $board_name = strtolower(str_replace(" ", $split_char, $board_name));
	                $board_exist = 1;
	            }
	        }
	         
	        if ($board_exist == 0) continue;
	         
	        $topic_name = remove_signs($topic['subject']);
	        $topic_name = strtolower(str_replace(" ", $split_char, $topic_name));
	         
	        $scripturl1 = str_replace("/index.php", "", $scripturl);
	         
	        echo '
	            <url>
	            <loc>', $scripturl1, '/', $topic_name, '-t', $topic['id'], '.0.html</loc>
	            <lastmod>', posts_max_time($topic['times']), '</lastmod>
	            <changefreq>', posts_to_freq($topic['times']), '</changefreq>
	            <priority>', posts_to_priority(0.7, $topic['times']), '</priority>
	            </url>';
	    }

	echo '
	    </urlset>';
	 
	function posts_max_time($post_times)
	{
	    if (empty($post_times) || count($post_times) == 1)
	        return gmstrftime('%Y-%m-%dT%H:%M:%S+00:00', time() - 3600 * 24 * 10);
	     
	    return gmstrftime('%Y-%m-%dT%H:%M:%S+00:00', max($post_times));
	}
	 
	function posts_to_priority($base, $post_times)
	{
	    if (empty($post_times) || count($post_times) == 1)
	        return sprintf('%1.1f', $base);
	     
	    $s = (max($post_times) - min($post_times)) / count($post_times);
	     
	    if ($s < 3600 * 24)
	        $mod = 0.1;
	    else
	        $mod = 0;
	     
	    return sprintf('%1.1f', $base + $mod);
	}
	 
	function posts_to_freq($post_times)
	{
	    if (empty($post_times) || count($post_times) == 1)
	        return 'yearly';
	     
	    $s = (max($post_times) - min($post_times)) / count($post_times);
	     
	    // Changes more often than every hour.
	    if ($s < 3600)
	        return 'always';
	    elseif ($s < 3600 * 12)
	    return 'hourly';
	    elseif ($s < 3600 * 24 * 4)
	    return 'daily';
	    else
	        return 'monthly';
	}
	 
?>
